import React from 'react';
import { Spin, Select, Input, Upload, Button, Checkbox } from 'antd';
import { UploadOutlined } from '@ant-design/icons';
import axios from "axios";
import select_data from '../../common/ssq';
import styleData from '../moduleCss/style.module.scss';

export default class centerW extends React.Component {
    constructor(props) {
        super(props)
        this.state = {
            selectData: select_data,
            rightArray: select_data.rightArray,
            fileList: [[], [], [], [], [], [], [], [], [], [], [], []],
            fileList_t: null,
            headerProps: {
                progress: {
                    strokeColor: {
                      '0%': '#108ee9',
                      '100%': '#87d068',
                    },
                    strokeWidth: 3,
                    format: percent => `${parseFloat(percent.toFixed(2))}%`,
                  }
            },
            imgType: null,
            Params: this.props.arr,
            tradingScenarios: [],
            datas: {},
            signedType: '',
            businessLicensePath: '',//营业执照照片路径
            openAccountPath: '',//开户许可证照片路径
            legalIdCardProsPath: '',//法人证件人像面路径
            legalIdCardConsPath: '',//法人证件国徽面路径
            desireAuthPath: '',//确认入网意愿视频路径
            holdingIdCardPath: '',//法人手持证件影印件路径
            webSitePath: '',//商户网址截图影印件路径
            wechatAppletPath: '',//公众号/小程序/生活号业务流程截图影印件路径	
            appPath: '',//APP首页截图影印件路径
            legalPersonBankCardPath: '',//法人银行卡图影印件路径
            desireAuthOtherPath: '',//确认入网意愿其他验证方式路径
            otherCerPath: '',//其他资质文件路径
            scLodings : null
        }

    }

    componentDidMount() {
        this.props.onRef(this);
        let signedType = JSON.parse(localStorage.getItem('oData')).signedType;
        this.setState({
            signedType: signedType
        })
    }

    toParent = (data) => {
        this.props.parent.getParams_w(this, data)
    }

    InputWdata(e) {
        let Params = {
            legalPersonName: document.getElementById("legalPersonName").value,//法人姓名
            profession: this.state.Params.profession, //法人职业
            legalPersonIdType: this.state.Params.legalPersonIdType == undefined ? '' : this.state.Params.legalPersonIdType,//法人证件类型
            legalPersonIdNo: document.getElementById("legalPersonIdNo").value, //证件号码
            idEffectiveDateStart: '',//法人证件有效期开始日期
            idEffectiveDateEnd: '',//法人证件有效期结束日期
            cerNoType: this.state.Params.cerNoType == undefined ? '' : this.state.Params.cerNoType,//企业证件类型
            cerNo: document.getElementById("cerNo").value,//企业资质证书编号
            sellingArea: this.state.Params.sellingArea == undefined ? '' : this.state.Params.sellingArea,//营业面积
            staffSize: this.state.Params.staffSize == undefined ? '' : this.state.Params.staffSize,//公司员工规模
            tradingScenarios: this.state.Params.tradingScenarios,//交易场景说明
            webSite: document.getElementById("webSite").value,//网站网址
            webSiteName: document.getElementById("webSiteName").value,//网站名称
            icp: document.getElementById("icp").value,//ICP备案号
            appName: document.getElementById("appName").value,//APP名称
            wechatAppletName: document.getElementById("wechatAppletName").value,//公众号/小程序/生活号
            testAccountInfo: '',//测试账户信息
            businessLicensePath: this.state.businessLicensePath,//营业执照照片路径
            openAccountPath: this.state.openAccountPath,//开户许可证照片路径
            legalIdCardProsPath: this.state.legalIdCardProsPath,//法人证件人像面路径
            legalIdCardConsPath: this.state.legalIdCardConsPath,//法人证件国徽面路径
            desireAuthPath: this.state.desireAuthPath,//确认入网意愿视频路径
            holdingIdCardPath: this.state.holdingIdCardPath,//法人手持证件影印件路径
            webSitePath: this.state.webSitePath,//商户网址截图影印件路径
            wechatAppletPath: this.state.wechatAppletPath,//公众号/小程序/生活号业务流程截图影印件路径	
            appPath: this.state.appPath,//APP首页截图影印件路径
            legalPersonBankCardPath: this.state.legalPersonBankCardPath,//法人银行卡图影印件路径
            desireAuthOtherPath: this.state.desireAuthOtherPath,//确认入网意愿其他验证方式路径
            otherCerPath: this.state.otherCerPath,//其他资质文件路径
        }
        localStorage.setItem('wData', JSON.stringify(Params))
        return Params
    }

    childMethod() { //暴露给父组件的方法,集合当前页面拿到的参数存入缓存
        let data = this.InputWdata();
        this.toParent(data)
    }

    btnClick(e) {  //区分上传图片类型
        let index = e + 1;

        this.setState({
            imgType: e
        })
    }

    selectChange_1(value) {  //法人职业类型选择
        this.state.Params.profession = value;
    }

    selectChange_2(value) {  //法人证件类型选择
        this.state.Params.legalPersonIdType = value;
    }

    selectChange_3(value) {  // 企业证件类型选择
        this.state.Params.cerNoType = value;
    }

    selectChange_4(value) {  // 营业面积
        this.state.Params.sellingArea = value;
    }

    selectChange_5(value) {  // 员工规模
        this.state.Params.staffSize = value;
    }

    CheckChange(e) {
        this.state.Params.tradingScenarios = e.toString()
    }

    onChangeUpload(info) {
        let fileList = [...info.fileList];
        this.state.fileList = fileList
    }
    UploadImgstate() {  //修改上传图片状态
        let fileList = this.state.fileList;
        
        let imgType = this.state.imgType; //当前上传图片点击的Index
        fileList[0].status = 'done'  //上传成功之后的状态 自动修改
        fileList[0].response = fileList[0].name  //图片上传成功之后展示的TIP
        let arr = this.state.fileList;
        arr[imgType] = fileList
        this.setState({
            fileList: arr
        })
    }

    handleChange(e) {
        let imgType = this.state.imgType;
        let file = e.file;
        let that_ = this;
        that_.setState({
            scLodings : true
        })
        const formData = new FormData();
        formData.append('file', file)
        formData.append('merchantSerialNumber', 'MCT_202106262257460929210')
        let config = {
            method: 'post',
            headers: { 'Content-Type': 'multipart/form-data' }
        }
        axios.post('http://paytest.zhongsou.com/payment/file.upload.groovy', formData, config).then((res) => {
            let status = res.data.msg;
            if (status == '获取成功') {
                let dataUrl = res.data.filesResult[0].fileName;
                that_.wjbc(imgType,dataUrl)
            }
        }).catch((error) => { //上传失败后设置回之前的上前数量与状态
            console.log(error);
        })
    }

    wjbc(e,dataUrl) {
        let that_ = this;
        let rightArray = this.state.rightArray;
        switch (e) {
            case 0:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    businessLicensePath : dataUrl,
                    scLodings : false
                })
                break;
            case 1:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    openAccountPath : dataUrl,
                    scLodings : false
                    
                })
                break;
            case 2:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    legalIdCardProsPath : dataUrl,
                    scLodings : false
                })
                break;
            case 3:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    legalIdCardConsPath : dataUrl,
                    scLodings : false
                })
                break;
            case 4:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    desireAuthPath : dataUrl,
                    scLodings : false
                })
                break;
            case 5:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    holdingIdCardPath : dataUrl,
                    scLodings : false
                })
                break;
            case 6:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    webSitePath : dataUrl,
                    scLodings : false
                })
                break;
            case 7:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    wechatAppletPath : dataUrl,
                    scLodings : false
                })
                break;
            case 8:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    appPath : dataUrl,
                    scLodings : false
                })
                break;
            case 9:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    legalPersonBankCardPath : dataUrl,
                    scLodings : false
                })
                break;
            case 10:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    desireAuthOtherPath : dataUrl,
                    scLodings : false
                })
                break;
            case 11:
                rightArray[e].txts = '上传成功'
                that_.setState({
                    rightArray: rightArray,
                    otherCerPath : dataUrl,
                    scLodings : false
                })
                break;
        }
    }







    // defaultValue={Params.signedName}
    render() {
        const { selectData, Params, signedType, rightArray,headerProps,scLodings,imgType } = this.state;
        const { Option } = Select;

        return (
            <div className={styleData.center_up}>
                <div className={styleData.center_left}>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 法人姓名<i className='label_x'>*</i> ： </div>
                        <div className={styleData.inputs}><Input id='legalPersonName' placeholder="请输入法人姓名" defaultValue={Params.legalPersonName} /></div>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 法人职业 ： </div>
                        <Select size='default' placeholder="请选择法人职业" defaultValue={Params.profession} onChange={this.selectChange_1.bind(this)} style={{ width: 200 }}>
                            {selectData.contractW.map((item, index) => (
                                <Option key={index} value={item.value}>{item.txt}</Option>
                            ))}
                        </Select>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 法人证件类型<i className='label_x'>*</i>： </div>
                        <Select size='default' placeholder="请选择证件类型" defaultValue={Params.legalPersonIdType} onChange={this.selectChange_2.bind(this)} style={{ width: 200 }}>
                            {selectData.certificateW.map((item, index) => (
                                <Option key={index} value={item.value}>{item.txt}</Option>
                            ))}
                        </Select>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 法人证件号码<i className='label_x'>*</i>： </div>
                        <div className={styleData.inputs}><Input id='legalPersonIdNo' placeholder="请输入证件号码" defaultValue={Params.legalPersonIdNo} /></div>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 企业证件类型{signedType == 'BY_SPLIT_BILL' && <i className='label_x'>*</i>} ： </div>
                        <Select size='default' placeholder="请选择证件类型" defaultValue={Params.cerNoType} onChange={this.selectChange_3.bind(this)} style={{ width: 200 }}>
                            {selectData.cerNoTypeW.map((item, index) => (
                                <Option key={index} value={item.value}>{item.txt}</Option>
                            ))}
                        </Select>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 资质证书编号{signedType == 'BY_SPLIT_BILL' && <i className='label_x'>*</i>} ： </div>
                        <div className={styleData.inputs}><Input id='cerNo' placeholder="请输入证书编号" defaultValue={Params.cerNo} /></div>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 营业面积{signedType == 'BY_SPLIT_BILL' && <i className='label_x'>*</i>} ： </div>
                        <div className={styleData.inputs}>
                            <Select size='default' placeholder="请选择营业面积" defaultValue={Params.sellingArea} onChange={this.selectChange_4.bind(this)} style={{ width: 200 }}>
                                <Option key={1} value='A'>500平米以上</Option>
                                <Option key={2} value='B'>200-500平米（含）</Option>
                                <Option key={3} value='C'>200平米以下</Option>
                            </Select>
                        </div>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 公司员工规模{signedType == 'BY_SPLIT_BILL' && <i className='label_x'>*</i>} ： </div>
                        <div className={styleData.inputs}>
                            <Select size='default' placeholder="请选择营业面积" defaultValue={Params.staffSize} onChange={this.selectChange_5.bind(this)} style={{ width: 200 }}>
                                <Option key={4} value='A'>100人以上</Option>
                                <Option key={5} value='B'>50-100人（含）</Option>
                                <Option key={6} value='C'>50人以下</Option>
                            </Select>
                        </div>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 交易场景说明<i className='label_x'>*</i> ： </div>
                        <Checkbox.Group options={selectData.options} defaultValue={['WEBSITE']} onChange={this.CheckChange.bind(this)} />
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 网站网址 ： </div>
                        <div className={styleData.inputs}><Input id='webSite' placeholder="请输入网站网址" defaultValue={Params.webSite} /></div>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 网站名称 ： </div>
                        <div className={styleData.inputs}><Input id='webSiteName' placeholder="请输入网站名称" defaultValue={Params.webSiteName} /></div>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> ICP备案号 ： </div>
                        <div className={styleData.inputs}><Input id='icp' placeholder="请输入ICP备案号" defaultValue={Params.icp} /></div>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> APP名称 ： </div>
                        <div className={styleData.inputs}><Input id='appName' placeholder="请输入APP名称" defaultValue={Params.appName} /></div>
                    </div>
                    <div className={styleData.cl}>
                        <div className={styleData.titles}> 公众号/小程序/生活号 ： </div>
                        <div className={styleData.inputs}><Input id='wechatAppletName' placeholder="请输入名称" defaultValue={Params.wechatAppletName} /></div>
                    </div>
                </div>
                <div className={styleData.center_right}>
                    {rightArray.map((item, index) => (
                        <div className={styleData.cl} key={index}>
                            <div className={styleData.titles}> {item.txt}{(item.value == 3 || item.value == 4) && <i className='label_x'>*</i>} ： </div>
                            <div className={styleData.Upload_wrap}>
                                <Upload
                                     {...headerProps}
                                    name="files"
                                    className={"Upload" + index}
                                    maxCount={1}
                                    showUploadList={false}
                                    accept={item.type}
                                    customRequest={this.handleChange.bind(this)}
                                    onChange={this.onChangeUpload.bind(this)}
                                    
                                >
                                    <Button icon={<UploadOutlined />} onClick={() => this.btnClick(index)}>选择文件</Button>
                                </Upload>
                                <div className={styleData.title_tips} style={{
                                    color : item.txts == '上传成功' ? 'green' : 'red' 
                                }} >
                                    {scLodings == true && imgType == index && <Spin size="small" tip="上传中..." style={{
                                        fontSize : '12px'
                                    }}></Spin>}
                                    {scLodings == true && imgType !== index && item.txts}
                                    {scLodings == null  && imgType !== index && item.txts}
                                    {scLodings == false && item.txts}
                                </div>
                            </div>
                        </div>
                    ))}
                </div>
            </div>
        )
    }
}